#include "map.h"
#include <stdio.h>
#include "aswm/log/log.h"
#include "aswm/mapper/mapper.h"
#include "X11/Xutil.h"

void OnMapRequest(Aswm* aswm, const XMapRequestEvent* e) {
	printf("XMapRequestEvent %lu\n", e->window);

	XSizeHints* size = XAllocSizeHints();
	long supplied;
	bool stacked = false;
	if(XGetWMNormalHints(aswm->display, e->window, size, &supplied)) {
		if((supplied & (PMinSize | PMaxSize)) && !aswm_is_resizeable(size)) {
			printf("\tWMNormalHints:\n");
			printf("\t\tMin w:%i\n", size->min_width);
			printf("\t\tMin h:%i\n", size->min_height);
			printf("\t\tMax w:%i\n", size->max_width);
			printf("\t\tMax h:%i\n", size->max_height);
			aswm_stack_window(e->display, aswm->current_desktop.stack_root, e->window, size->max_width, size->max_height);
			stacked = true;
		}
	}
	XFree(size);

	if(!stacked)
		aswm_tile_window(e->display, aswm->current_desktop.tile_root, e->window);

	printf("Map tree:\n");
	log_tree(aswm, DefaultRootWindow(aswm->display), 1);
}
